<template>
  <div style="display: flex; justify-content: space-between;">
    <div>
      <label>Фильтр</label>
      <input v-model="jobFilter" />
      <button @click="showOnlyFromMosaic()">Вошли в мозаику</button>
    </div>
    <div>
      <button @click="saveProduct('list')">Сохранить</button>
      <input v-model="productListName" />
      <label>{{result}}</label>
    </div>
    <div>
        <a href="#" @click.prevent="goToTask()">{{uid}}</a>
    </div>

  </div>  

  <table-lite
    :is-static-mode="true"
    :columns="jobTable.columns"
    :rows="jobTable.rows"
    :total="jobTable.totalRecordCount"
    :page="taskPage"
    :page-size=5
    :messages="jobTable.messages"
    @is-finished="tableLoadingFinish"
    @get-now-page="setCurrentPage" >
  ></table-lite>

 <loader :active="loaderActive" message="Загрузка данных" />  

 <div v-if="crop">
      <div id="map">
        <yandex-map
            :coords="coords"
            :map-type="'map'"
            :show-all-markers="true"
            :controls="['fullscreenControl']">

            <ymap-marker
              marker-id="1"
              :marker-type="'Polygon'"
              :coords="taskCrop"
              :marker-stroke="{color: '#ff0000', width: 3}"
              :marker-fill="{color: '#f00000', opacity: 0.2}"
            >
            </ymap-marker>

            <div v-for="item in jobCrop" v-bind:key="item.id">
             <ymap-marker
                marker-id="2"
                :marker-type="'Polygon'"
                :coords="item.crop"
                :marker-fill="{color: '#0000f0', opacity: 0.2}"
                :marker-stroke="{color: '#0000ff', width: 1}"
                :hint-content="item.name"
              >
              </ymap-marker>
            </div>
        </yandex-map>
    </div>
  </div>
  <div v-else>
    <p> {{ noCrop }} </p>
  </div>
  
  <div v-if="isQualityTable">
    <div>
      <label>Фильтр</label>
      <input v-model="qaFilter" />
      <button @click="saveTextClipBoard()">Копировать</button>
    </div>
    <table-lite
      :is-static-mode="true"
      :columns="qualityTable.columns"
      :rows="qualityTable.rows"
      :total="qualityTable.totalRecordCount"
      :page-size=5
      :messages="qualityTable.messages"
    ></table-lite>
  </div>

  <div v-for="item in images" v-bind:key="item.name">
    <div style="display: flex; justify-content: space-between;">
      <div>
        <label>{{item.name}}</label>
        <button @click="saveImageClipboard()">Копировать</button>
      </div>
      <div>
        <label style="font-weight:bold">Cloud</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label >{{item.Cloud}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Water</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Water}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Snow</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Snow}}</label>
      </div>
       <div>
        <label style="font-weight:bold">Defects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Defects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">DDefects</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.DDefects}}</label>
      </div>
      <div>
        <label style="font-weight:bold">Shadows</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.Shadows}}</label>
      </div>
      <div>
        <label style="font-weight:bold">StitchingMs</label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <label>{{item.StitchingMs}}</label>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.productQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.routeQualityStatus}}</a>
      </div>
      <div>
        <label style="font-weight:bold"></label>
        <span style="padding: 0px 1px;">&nbsp;</span>
        <a target="_blank" :href="item.qarpath">{{item.summaryQualityStatus}}</a>
      </div>
    </div>
    <!-- <img :src="item.path" style="width:100%;height: 500px; object-fit: cover; object-position: bottom;"/> -->
    <a rel="nofollow" :href="item.job2Path">
      <img id = 'quicklook' :src="item.rpath" style="width:100%;"/>
      <p></p>
    </a>
  </div>

</template>


<script>
import { watch, defineComponent, reactive, ref, computed, toRaw } from "vue";
import TableLite from "../components/TableLite.vue";
import axios from 'axios';
import router from "../router/index.ts"
import Loader from '../components/Loader.vue'
import {redouteProvider} from  "../config/provider.js"

import * as helper from './helper.js'

var storeTaskPage = 1
var onlyFromMosaic = false
let result = ref('')

const productListName = ref('')

let timerUpdateCrop = null

export default defineComponent({ 
  name: "App",
  components: { TableLite, Loader },

  setup() {
    const jobFilter = ref(""); // Search text
    const qaFilter = ref(""); // Search text

    let config = {}

    const jobData = reactive([]);
    const qualityData = reactive([]);

    const coords = reactive([])
    const taskCrop = reactive([])
    const jobCrop = reactive([])
    const crop = ref(false)
    const noCrop = ref("")
    const uid = ref("")
    const loaderActive = ref(true)
    const taskPage = ref("")
    const isQualityTable = ref(false)

    taskPage.value = storeTaskPage

    const url = new URL(window.location.href)
    const taskId = url.searchParams.get("task_id")
    const paramJobId = url.searchParams.get("job_id")
    const jobId = paramJobId != null ? paramJobId : '' 

    function cleverUpdateCrop() {
      if (timerUpdateCrop) clearTimeout(timerUpdateCrop);
      timerUpdateCrop = setTimeout(() => { 
        let ar = []
      // если заданы строки таблицы, то показываем заданные шейпы марщшрутов 
      let jobTableRows = toRaw(jobTable.rows)
      for(let row of jobTableRows) {
        let r = toRaw(row)
        console.log(...toRaw(r.input))
        ar.push(...toRaw(r.input))  
      }
      updateCrop(ar) 
      } ,1000);
    }

    watch(jobFilter, () =>  cleverUpdateCrop())

    updateView()

    let images = reactive([])

    // Job Table config
    const jobTable = reactive({
      columns: [
        {
          label: "input",
          field: "input",
          width: "30%",
          display: function (row) {
            if (row.input && row.input.length > 1) 
              return 'Всего маршрутов: ' + row.input.length
            else 
              return row.input
          },          
        },
        {
          label: "output",
          field: "output",
          width: "10%",
          display: function (row) {
            if (row.output && 
                ( row.output.toString().includes('L1') || 
                  row.output.toString().includes('L2') || 
                  row.output.toString().includes('L3')
                ) 
                && !row.output.toString().includes('SCN') 
                ) {
              return (
                '<a href="javascript:void(0)" data-id="' +
                row.task_id + ',' + row.job_id +
                '" class="is-rows-el job-btn">' +
                row.output +
                "</a>"
              )
            }
            else {
              if (row.output && row.output.toString().includes('SCN')) {
                return (
                  '<a href="javascript:void(0)" data-id="' +
                  row.task_id + ',' + row.job_id +
                  '" class="is-rows-el job-btn">' +
                  '... SCN (Всего - ' + row.output.length + ')' +
                  "</a>"
                  )
              }
              else if (row.output && row.output.toString().includes('L0')) {
                return (
                  '... L0 (Всего - ' + row.output.length + ')'
                  )
              }
              else
                return row.output
            }
          },          
        },
        {
          label: "start",
          field: "start",
          width: "15%",
        },
        {
          label: "duration",
          field: "duration",
          width: "15%",
        },
        {
          label: "exit_code",
          field: "exit_code",
          width: "3%",
          sortable: false,
          display: function (row) {
            let exit = row.exit_code
            if (!exit) exit = 'processing'
            return (
              '<a href="javascript:void(0)" data-id="' +
              row.task_id + ',' + row.job_id +
              '" class="is-rows-el log-btn">' +
              exit +
              "</a>"
            );
          },          
        },
/*        
        {
          label: "",
          field: "",
          width: "3%",
          display: function (row) {
            return (
              '<button type="button" data-id="' +
              row.task_id + ',' + row.job_id +
              '" class="is-rows-el run-btn">!</button>'
            );
          },
        },        
*/
          ],
      rows: computed(() => {
        let ar = jobData.filter(
          (x) => {
            let fields = [x.input, x.output, x.exit_code]
            if (x.input.length > 1)            
                fields = [x.output, x.exit_code]
            return ok(fields,jobFilter.value)
          }
        )
        return ar

      }),
      totalRecordCount: computed(() => {
        return jobTable.rows.length;
      }),
      messages: {
        pagingInfo: "{0}-{1}/{2}",
        pageSizeChangeLabel: "Строк:",
        gotoPageLabel: "Перейти:",
        noDataAvailable: "Нет данных",
      },      
     });

     function ok (fields, value) {
      if (!value) return true
      let ret = false
      for (let field of fields) {
        ret = field && field.toString().toLowerCase().includes(value.toLowerCase())
        if (ret) break
      }
      return ret  
    }

     const tableLoadingFinish = (elements) => {
      jobTable.isLoading = false;
      Array.prototype.forEach.call(elements, function (element) {
        if (element.classList.contains("log-btn")) {
          element.addEventListener("click", function () { 
            goToLog(this.dataset.id)
          });
        }
        if (element.classList.contains("run-btn")) {
          element.addEventListener("click", function () {
            goToRun(this.dataset.id)
          });
        }
        if (element.classList.contains("job-btn")) {
          element.addEventListener("click", function () {
            goToJob2(this.dataset.id)
          });
        }
      });
      mainGoToJob2(url, taskId, jobId, images)
    };

  function  mainGoToJob2(url, taskId, jobId, images) {
    let request = redouteProvider + '/images'
    if (taskId) request = request + '?task_id=' + taskId + '&job_id=' + jobId
    axios.get(request, {})
    .then(response => { 
        if (response.data) {
          response.data.forEach(element => {
            element.rpath = redouteProvider+'/image?' + 'name=' + element.path
            element.qarpath = redouteProvider+'/file?' + 'name=' + element.qa
            let plainJobData = toRaw(jobData)
            let row = plainJobData[jobData.length-1]
            if (row)
              element.job2Path = url.origin + '/job2' + '?task_id=' + row.task_id + '&job_id=' + row.job_id
            images.push(element)
          })
        }
      })
      .catch(error => { 
        //jobTable.messages.noDataAvailable = 'Сервер "' + request + '" не отвечает ' + error
        images.push({name:error})
      })
    }

    function goToLog (id) {
      // в строке хранятся 2 числа через запятую task,job
      let part = id.split(',')
      router.push({ path: '/log', query: { task_id: part[0], job_id: part[1] } })
    }

    function goToJob2 (id) {
      // в строке хранятся 2 числа через запятую task,job
      let part = id.split(',')
      router.push({ path: '/job2', query: { task_id: part[0], job_id: part[1] } })
    }

    function goToTask () {
      router.push({ path: '/task', query: { uid: uid.value }} )
    }


    function goToRun (id) {
      // в строке хранятся 2 числа через запятую task,job
      let part = id.split(',')
      let request = redouteProvider + '/run'
      request = request + '?task_id=' + part[0] + '&job_id=' + part[1]
      axios.get(request, config);
      // goToLog(id)
    }
    
    const setCurrentPage = (pageNumber) => {
        storeTaskPage = pageNumber
      };



    // Quality Table config
    const qualityTable = reactive({
      columns: [
        {
          label: "product",
          field: "product",
          width: "50%",
        },
        {
          label: "count",
          field: "count",
          width: "30%",
        },
        {
          label: "L0beforeRFM_m",
          field: "L0beforeRFM_m",
          width: "30%",
          sortable: true,
        },
        {
          label: "L0afterRFM_m",
          field: "L0afterRFM_m",
          width: "30%",
          sortable: true,          
        },
        {
          label: "L1beforeBA_m",
          field: "L1beforeBA_m",
          width: "30%",
          sortable: true,
        },
        {
          label: "L1afterBA_m",
          field: "L1afterBA_m",
          width: "30%",
          sortable: true,
        },
        {
          label: "L1beforeBA_bind_px",
          field: "L1beforeBA_bind_px",
          width: "30%",
          sortable: true,
        },
        {
          label: "L1afterBA_bind_px",
          field: "L1afterBA_bind_px",
          width: "30%",
          sortable: true,
        },

      ],
      rows: computed(() => {
        return qualityData.filter(
          (x) => {
          if (!x) return 'null'
          let fields = [x.product]
          return ok(fields,qaFilter.value)
          }
        )
      }),
      totalRecordCount: computed(() => {
        return qualityTable.rows.length;
      }),
      messages: {
        pagingInfo: "{0}-{1}/{2}",
        pageSizeChangeLabel: "Строк:",
        gotoPageLabel: "Перейти:",
        noDataAvailable: "Получение данных ...",
      },      
     });

    function updateView() {
      if (onlyFromMosaic == true) {
        // получаем маршруты, которые вошли в мозаику после отбора esprit
        let request = redouteProvider + '/approved'
        if (taskId) request = request + '?task_id=' + taskId
        axios.get(request, {})
          .then(response => { 
            // инициализация таблицы заданий
            jobData.splice(0,jobData.length)
            updateJobTable(response.data)
            // если показываем только то, что вошло в мозаику, то с фрагментами
            updateCrop(response.data)
          })
          .catch(error => { 
            jobTable.messages.noDataAvailable = 'Сервер "' + request + '" не отвечает ' + error
          })
      }
      else {
        // все, что отобрал spirit
        updateJobTable(null)
        updateCrop(null)
      }
    }

    function updateJobTable(routeId) {
      isQualityTable.value = false

      jobData.splice(0, jobData.length)
      let request = redouteProvider + '/job'
      if (taskId) request = request + '?task_id=' + taskId + '&job_id=' + jobId
      axios.post(request, JSON.stringify(routeId))
        .then(response => { 
          // инициализация таблицы заданий
          if (response.data && response.data.length > 0) {
            response.data.forEach(element => {
              if (element.exit_code == null)  {
                if (element.dlit != null) element.exit_code = 'no_data'
                else element.exit_code = ''
              }
              jobData.push(element) 
            })
          }    
          else {
            jobTable.messages.noDataAvailable = "Нет данных"
          }
        })
        .catch(error => { 
          jobTable.messages.noDataAvailable = 'Сервер "' + request + '" не отвечает ' + error
        })

      // оценки качества
      qualityData.splice(0, qualityData.length)
      request = redouteProvider + '/quality'
      if (taskId) request = request + '?task_id=' + taskId + '&job_id=' + jobId
      axios.post(request,JSON.stringify({ fileNames: routeId, limit: 100 } ))
        .then(response => { 
          // инициализация таблицы качества
          if (response.data && response.data.length > 0) {
            isQualityTable.value = true
             response.data.forEach(element => {
              qualityData.push(element) 
             })    
          }
          else {
            qualityTable.messages.noDataAvailable = "Нет данных"
          }
        })
        .catch(error => { 
          qualityTable.messages.noDataAvailable = 'Сервер "' + request + '" не отвечает ' + error
        })

      // uid задания для отображения на странице  
      request = redouteProvider + '/uid'
      if (taskId) request = request + '?task_id=' + taskId
      axios.get(request, {})
        .then(response => { 
          uid.value = response.data.uid
          })    
    }

    function updateCrop(ar) {
      // отрисовать заново карту
      crop.value = false
      loaderActive.value = true;

      // иначе массив пустой и в сервисе возьмутся фрагменты для мозаик

      // контуры маршрутов    
      //taskCrop.splice(0,taskCrop.length)
      //jobCrop.splice(0,jobCrop.length)
      //if (coords) coords.splice(0,coords.length)
      let request = redouteProvider + '/crop'
      if (taskId) request = request + '?task_id=' + taskId
      axios.post(request, JSON.stringify({ fileNames: ar, limit: 100 } ))
        .then(response => { 
          loaderActive.value = false;
          // в первом элементе response.data[0] всегда хранится контур задания
          if (response.data && response.data[0] && response.data[0].crop  && response.data[0].crop[0] && response.data[0].crop[0][0]) {
            crop.value = true
            coords.push(...response.data[0].crop[0][0])
            taskCrop.push(response.data[0].crop[0])
          }

          // в остальных контуры продуктов или промежуточных маршрутов  
          jobCrop.splice(0,jobCrop.length)
          let totalCrop = response.data.length
          for (let i=1; i<totalCrop; i++)  {
            crop.value = true
            if (response.data && response.data[i] && response.data[i].crop[0])
            {
              coords.push(...response.data[i].crop[0][0])
              let ar = []
              ar.push(response.data[i].crop[0])
              jobCrop.push({ name: response.data[i].name, crop: ar })
            }
          }
        })
        .catch(error => { 
          loaderActive.value = false
          alert(error)
        })      
    }

    function showOnlyFromMosaic()  {
      onlyFromMosaic = true
      updateView()
    }

    function saveTextClipBoard()  {
      let ret = ''
      let rows = qualityTable.rows;
      for (let row of rows) {
        for (let item in row) {
          ret += row[item] + '\t'
        }
        ret += '\n'
      }
      helper.copyToClipboard(ret)
    }
  


    async function gsheet()  {

      let API_KEY = 'AIzaSyA8vrrl2mQZJZ0EXLexP55z7RjqSnoZ-6k'
      let fetch_url = `https://docs.googleapis.com/v1/documents?key=${API_KEY}`;
      let fetch_options = {
        method: "POST",
        headers: {
          //Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
        },
        body: JSON.stringify({
          title: "Example of a Doc created programmatically",
        }),
      };

      fetch(fetch_url, fetch_options)
        .then((res) => res.json())
        .then((res) => {
          console.log(res);
        });      
/*      
      // Initialize auth - see https://theoephraim.github.io/node-google-spreadsheet/#/guides/authentication
      const serviceAccountAuth = new JWT({
        // env var values here are copied from service account credentials generated by google
        // see "Authentication" section in docs for more info
        email: process.env.GOOGLE_SERVICE_ACCOUNT_EMAIL,
        key: process.env.GOOGLE_PRIVATE_KEY,
        scopes: [
          'https://www.googleapis.com/auth/spreadsheets',
        ],
      });

      const doc = new GoogleSpreadsheet('<the sheet ID from the url>', serviceAccountAuth);

      await doc.loadInfo(); // loads document properties and worksheets
      console.log(doc.title);
      await doc.updateProperties({ title: 'renamed doc' });

      const sheet = doc.sheetsByIndex[0]; // or use `doc.sheetsById[id]` or `doc.sheetsByTitle[title]`
      console.log(sheet.title);
      console.log(sheet.rowCount);

      // adding / removing sheets
      const newSheet = await doc.addSheet({ title: 'another sheet' });
      await newSheet.delete();
*/
    }

    async function saveImageClipboard() {
      const image = document.getElementById('quicklook')      
      helper.copyImageToClipboard(image.src)
    }

    function saveProduct(action)  {
      let dataServer = redouteProvider + '/' + 'saveProduct'

      // отобранные записи попадают в массив
      let arProduct = []
      let rows = jobTable.rows;
      for (let row of rows) {
        if (row.input && row.input[0] && row.input[0].includes('L0') )
          arProduct.push({ productId: row.input } )
      }

      let postData = {  input:  arProduct,
                        name:   productListName.value,
                        action: action,
                     }

      axios.post(dataServer, JSON.stringify(postData)  )
        .then(function (response) {
          result.value = response.data
        })
        .catch(function (error) {
          result.value = error
        });  
    }

    return {
      jobFilter,
      qaFilter,
      tableLoadingFinish,      
      jobTable,
      qualityTable,
//    refines,
      images,
      coords,
      taskCrop,
      jobCrop,
      crop,
      noCrop,
      uid,      
      loaderActive,
      setCurrentPage,
      taskPage,
      updateView,
      showOnlyFromMosaic,
      saveTextClipBoard,  
      saveImageClipboard,    
      productListName,
      saveProduct,
      gsheet,
      isQualityTable,   
      result,  
      goToTask, 
    };
  },
});



</script>


<style scoped>

  :deep(.vtl-table td, .vtl-table th) {
    padding: 0.1rem;
    font-size: smaller;
  }

  :deep(.success) {
    color: green  
  }
  :deep(.error) {
    color: red
  }


  #map {
      font-family: 'Avenir', Helvetica, Arial, sans-serif;
      -webkit-font-smoothing: antialiased;
      -moz-osx-font-smoothing: grayscale;
      text-align: center;
      color: #2c3e50;
  }
  .ymap-container {
      height: 300px;
      width:  auto; 
  }
  .red {
      color: red;
  }
</style>